'Coded by UEZ build 2024-01-25
'
'WINDOWS ONLY!!!

#ifdef __FB_64BIT__
	#cmdline "-s gui -gen gcc -Wc -Os -x 'GDI+ Swiss Railway Clock v1.30_x64.exe' 'GDI+ Swiss Railway Clock v1.30.rc'"
#else
	#cmdline "-s gui -gen gcc -Wc -Os 'GDI+ Swiss Railway Clock v1.30.rc'"
#endif

#define WIN_INCLUDEALL

#include once "fbgfx.bi"
#include once "String.bi"
#include once "vbcompat.bi"

#include once "windows.bi"
#include once "/win/commctrl.bi"

#define WM_TRAYICON WM_APP + 1

#ifdef __FB_64BIT__ '...'
	#inclib "gdiplus"
	#include once "win/gdiplus-c.bi"
	#define GCL_HICON (-14)
	#define GCL_HICONSM (-34)
#else
	#include "crt/math.bi"
	#include once "win/gdiplus.bi"
	Using Gdiplus
#endif
#include once "WinHTTP.bi"

Using FB

#define LimCol(c) 	(max(0, min(255, c)))
Dim Shared As String sTitle, sVer
sVer = "v1.30 build 2024-01-25"
sTitle = "GDI+ Swiss Railway Clock " & sVer

#ifndef CRLF '...'
	#define CRLF	Chr(10, 13)
#endif

Dim Shared As HWND hWND_About
Dim Shared As Any Ptr pImage_About, hDC_About, hHBitmap_About, hDC_backbuffer_About, hDC_obj_About, hCanvas_About, hPen_About, hBrush_About, hBitmap_Scroller_About
Dim Shared As Double fTimer_About
Const iW_About = 640, iH_About = 360, iw2 = iW_About \ 2, ih2 = iH_About * 0.583333
Dim Shared As Long iH_ScrollerTxt, iStartPos_Scroller_About

Dim Shared As String sScroller_Txt
sScroller_Txt = _
				"GDI+ Swiss Railway Clock" & CRLF & _
				sVer & CRLF & _
				"coded by" & CRLF & _
				"UEZ" & CRLF & CRLF & CRLF & CRLF & _
				"Thanks to:" & CRLF & _
				"trancexx" & CRLF & _
				"Mattias Fagerlund" & CRLF & _
				"keithclark" & CRLF & _
				"Lazycat" & CRLF & CRLF & CRLF & CRLF & _
				"Greetings to:" & CRLF & _
				"Freebasic Community" & CRLF & _
				"Autoit Community" & CRLF & CRLF & CRLF & CRLF & _
				"Press ESC to exit" & CRLF & CRLF & _
				"-----------------------------" & CRLF & CRLF & _
				"This program is freeware" & CRLF & _
				"under Creative Commons License" & CRLF & _
				"by-nc-nd 3.0'!"

Declare Sub Update()
Declare Function GenerateClockBg(fDiameter As UShort) As Any Ptr
Declare Function Base91Decode(sString As String, ByRef iBase91Len As ULong) As UByte Ptr
Declare Function _GDIPlus_BitmapCreateFromMemory2(aBinImage As UByte Ptr, iLen As ULong, bBitmap_GDI As BOOL = False) As Any Ptr
Declare Function WndProc(hWnd As HWND, uMsg As UINT, wParam As WPARAM, lParam As LPARAM) As Integer
Declare Function _GDIPlus_GraphicsGetDPIRatio(iDPIDef As UShort = 96) As Single
Declare Sub _GDIPlus_BitmapApplyFilter_FastBoxBlur(ByVal hImage As Any Ptr, range As ULong)
Declare Sub FastBoxBlurH(hImage As Any Ptr, range As ULong)
Declare Sub FastBoxBlurV(hImage As Any Ptr, range As ULong)
Declare Sub CreateTransparentSettingWindow()
Declare Sub CreateTransparentBgSettingWindow()
Declare Sub CreateGUISizeSettingWindow()
Declare Function _WinAPI_IniRead(sIniFile As String, sSection As String, sKey As String, sDefault As String = "default") As String
Declare Function _WinAPI_IniWrite(sIniFile As String, sSection As String, sKey As String, sValue As String = "default") As Integer
Declare Function _WinAPI_CreateToolTip(hDlg As HWND, sToolTipText As String, bBalloon As UByte = 1) As HWND
Declare Function _WinAPI_SetProcessDpiAware() As UByte
Declare Function _WinAPI_SetProcessDpiAwareness(DPIAwareFlag As Integer) As UByte
Declare Sub SetGUISize(iSliderPos As Long)
Declare Sub About(sScroller_Txt As String)
Declare Function Check4NewVersion(check As String, ByRef sNewVersion As String) As Byte
Declare Function Check4TLS() As Long
Declare Function _WinAPI_IsCursorOverGui(hWnd As HWND) As BOOL

Enum PROCESS_DPI_AWARENESS '...'
	DPI_AWARENESS_INVALID = -1
	PROCESS_DPI_UNAWARE = 0
	PROCESS_SYSTEM_DPI_AWARE = 1
	PROCESS_PER_MONITOR_DPI_AWARE = 2
End Enum

Declare Function RtlGetVersion Lib "NtDll.dll" Alias "RtlGetVersion" (OsVersionInformation As RTL_OSVERSIONINFOW) As Long

Dim Shared As RTL_OSVERSIONINFOW tOSVERSIONINFO
tOSVERSIONINFO.dwOSVersionInfoSize = SizeOf(RTL_OSVERSIONINFOW)
RtlGetVersion(tOSVERSIONINFO)

If tOSVERSIONINFO.dwBuildNumber < 2600 Then  '...'
	MessageBox(NULL, "This operating system is not supported!", "ERROR", MB_ICONERROR)
	End
End If
Dim As UByte iReturn
Select Case tOSVERSIONINFO.dwBuildNumber '...'
Case 6000 To 9199
	iReturn = _WinAPI_SetProcessDpiAware()
Case 9200 To 20000
	iReturn = _WinAPI_SetProcessDpiAwareness(PROCESS_PER_MONITOR_DPI_AWARE)
End Select

Dim Shared gdipToken As ULONG_PTR
Dim Shared GDIp As GdiplusStartupInput
GDIp.GdiplusVersion = 1
If GdiplusStartup(@gdipToken, @GDIp, NULL) <> 0 Then End -1

SetPriorityClass(GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS)

Dim As Integer sW, sH
ScreenInfo(sW, sH)
Dim Shared As UShort iW, iH
Dim Shared As Short ScreenW_old, ScreenH_old, ScreenL_old, ScreenT_old
Dim As UByte iSnapGapDefault = 20
Dim Shared As Single fDPI
fDPI = _GDIPlus_GraphicsGetDPIRatio()

Dim As String sPath2Ini = ExePath & "\GDI+ Swiss Railway Clock.ini"
iW = CUShort(_WinAPI_IniRead(sPath2Ini, "Settings", "WinSize", Str(200)))
iW = IIf(iW < 64, 64, IIf(iW > 800, 800, iW))
iH = iW
Dim Shared As Single fDefaultPosX, fDefaultPosY
fDefaultPosX = (sW - iW) / 2
fDefaultPosY = (sH - iH) / 2

Dim As Short xPos = CShort(_WinAPI_IniRead(sPath2Ini, "Settings", "x", Str(fDefaultPosX)))
Dim As Short yPos = CShort(_WinAPI_IniRead(sPath2Ini, "Settings", "y", Str(fDefaultPosY)))
Dim Shared As Byte iAutostart, iAlwaysOnTop, iClickThru, iSnap, iShowDate, iHover = 0, iClockSecondHandStepping
Dim Shared As UByte iSwissRailwayClock, iAlpha, iBgTransparency, iSnapGab, iShowSeconds, iShowShadowBorder, iShowBrushedBorder, iShowClockDial, iShowShadowSecondHand, _
					iShowShadowMinuteHand, iShowShadowHourHand, iSecondHandType, iShowLogo
Dim Shared As ULong iClockDialColorBig, iClockDialColorSmall, iClockBgColorStart, iClockBgColorEnd, iClockSecondHandColor, iClockMinuteHandColor, iClockHourHandColor, _
					iClockCenterRingColor, iClockCenterBottomColor, iClockBrandingColor, iShadowColor
Dim As String sChk

#macro CheckPrefix(sChk) '...'
	CLng(IIf(Left(sChk, 2) = "0x", "&h" & Mid(sChk, 3), sChk))
#endmacro

iSwissRailwayClock = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "SwissRailwayClock", "1"))
iAutostart = CByte(_WinAPI_IniRead(sPath2Ini, "Settings", "Autostart", "-1"))
iAutostart = IIf(iAutostart < -1 Or iAutostart > 1 Or iAutostart = 0, -1, iAutostart)
iAlwaysOnTop = CByte(_WinAPI_IniRead(sPath2Ini, "Settings", "AlwaysOnTop", "1"))
iAlwaysOnTop = IIf(iAlwaysOnTop < -1 Or iAlwaysOnTop > 1 Or iAlwaysOnTop = 0, 1, iAlwaysOnTop)
iShowDate = CByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowDate", Str(0)))
iShowDate = IIf(iShowDate < -1 Or iShowDate > 1 Or iShowDate = 0, -1, iShowDate)
iAlpha = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "Transparency", "255"))
iClickThru = CByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ClickThru", "-1"))
iBgTransparency = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "BgTransparency", "255"))
iShowSeconds = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowSeconds", "1"))
iShowSeconds = IIf(iShowSeconds < 0, 0, IIf(iShowSeconds > 2, 2, iShowSeconds))
ScreenW_old = CShort(_WinAPI_IniRead(sPath2Ini, "Settings", "ScreenW", Str(0)))
ScreenH_old = CShort(_WinAPI_IniRead(sPath2Ini, "Settings", "ScreenH", Str(0)))
ScreenL_old = CShort(_WinAPI_IniRead(sPath2Ini, "Settings", "ScreenL", Str(0)))
ScreenT_old = CShort(_WinAPI_IniRead(sPath2Ini, "Settings", "ScreenT", Str(0)))
iSnap = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "Snap", "1"))
iSnap = IIf(iSnap < -1 Or iSnap > 1 Or iSnap = 0, 1, iSnap)
iSnapGab = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "SnapGap", Str(iSnapGapDefault)))
iShowLogo = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowLogo", "1"))
iShowShadowBorder = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowShadowBorder", "1"))
iShowBrushedBorder = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowBrushedBorder", "1"))
iShowClockDial = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowClockDial", "1"))
iShowShadowSecondHand = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowShadowSecondHand", "1"))
iShowShadowMinuteHand = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowShadowMinuteHand", "1"))
iShowShadowHourHand = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ShowShadowHourHand", "1"))
iShadowColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ShadowColor", "&h20A0A0A0"))
iClockDialColorBig = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockDialColorBig", "&hFF000000"))
iClockDialColorSmall = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockDialColorSmall", "&hFF000000"))
iClockBgColorStart = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockBgColorStart", "&hE8E8E8"))
iClockBgColorEnd = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockBgColorEnd", "&hFFFFFF"))
iClockSecondHandColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockSecondHandColor", "&hFFC01010"))
iClockMinuteHandColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockMinuteHandColor", "&hFF101010"))
iClockHourHandColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockHourHandColor", "&hFF101010"))
iClockCenterRingColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockCenterRingColor", "&hFFA02020"))
iClockCenterBottomColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockCenterBottomColor", "&hFF101010"))
iClockBrandingColor = CheckPrefix(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockBrandingColor", "&hFF000000"))
iClockSecondHandStepping = CByte(_WinAPI_IniRead(sPath2Ini, "Settings", "ClockSecondHandStepping", "-1"))
iClockSecondHandStepping = IIf(iClockSecondHandStepping < -1 Or iClockSecondHandStepping > 1 Or iClockSecondHandStepping = 0, -1, iClockSecondHandStepping)
iSecondHandType = CUByte(_WinAPI_IniRead(sPath2Ini, "Settings", "SecondHandTyp", "1"))
iSecondHandType = IIf(iSecondHandType < 1 Or iSecondHandType > 3, 1, iSecondHandType)

iClockBgColorStart And = &hFFFFFF
iClockBgColorEnd And = &hFFFFFF

If iShowSeconds = 1 Then iHover = 1

Dim Shared As Single fPi, fRad, fDeg
fPi = Acos(-1)
fRad = fPi / 180
fDeg = 180 / fPi

'Region Windows GUI
Dim Shared WinClass As WNDCLASSEX
Dim Msg As MSG
Dim Shared As UByte bGUITrans, bGUISize, bGUIMsgbox
bGUITrans = 0
bGUISize = 0
bGUIMsgbox = 0

With WinClass '...'
	.style         = CS_HREDRAW Or CS_VREDRAW
	.lpfnWndProc   = @WndProc
	.cbClsExtra    = NULL
	.cbWndExtra    = NULL
	.hInstance     = GetModuleHandle(NULL)
	.hIcon         = LoadIcon(NULL, "FB_PROGRAM_ICON")
	.hCursor       = LoadCursor(NULL, IDC_ARROW)
	.hbrBackground = GetStockObject(WHITE_BRUSH)
	.lpszMenuName  = NULL
	.lpszClassName = StrPtr(sTitle)
	.cbSize		   = SizeOf(WNDCLASSEX)
End With

Dim Shared As Integer iStyleEx = 0
If iAlwaysOnTop = 1 Then iStyleEx = WS_EX_TOPMOST
If iClickThru = 1 Then iStyleEx = iStyleEx Or WS_EX_TRANSPARENT

Dim Shared As HWND hGUI, hGUI_TransparentSettings, hSlider_TransparentSettings, hLabel_TransparentSettings, hButton_TransparentSettings, _
hGUI_GUISizeSettings, hSlider_GUISizeSettings, hLabel_GUISizeSettings, hButton_GUISizeSettings, _
hGUI_TransparentBgSettings, hSlider_TransparentBgSettings, hLabel_TransparentBgSettings, hButton_TransparentBgSettings
Dim Shared As Long iSliderPos, iSliderPosPrev
Dim Shared As PAINTSTRUCT tPaintStruct

RegisterClassEx(@WinClass)
hGUI = CreateWindowEx(	WS_EX_LAYERED Or WS_EX_TOOLWINDOW Or iStyleEx, _
																		WinClass.lpszClassName, sTitle, _
																		WS_POPUP Or WS_VISIBLE, _
																		xPos, yPos, _
																		0, 0, _
																		NULL, NULL, WinClass.hInstance, NULL)

Dim Shared As HCURSOR CustomCursor
CustomCursor = LoadCursor(NULL, IDC_SIZEALL)

'Region Tray Menu
Dim Shared As NOTIFYICONDATA SystrayIcon
Dim HICON As HICON = ExtractIcon(GetModuleHandle(0), Command(0), 0)
Const WM_SHELLNOTIFY = WM_USER + 5

With SystrayIcon '...'
	.cbSize = Len(SystrayIcon)
	.hWnd = hGUI
	.uID = 1&
	.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
	.uCallbackMessage = WM_SHELLNOTIFY
	.hIcon = HICON
	.szTip = "GDI+ Swiss Railway Clock" & CRLF & "Press right mouse button to open menu" + Chr(0)
End With


Const ID_About = 1000, ID_Exit = 1001, ID_Reset = 1002, ID_Autostart = 1003, ID_AlwaysOnTop = 1004, ID_SetGUISize = 1005, _
	  ID_SetGUITransLevel = 1006, ID_ClickThru = 1007, ID_SetGUIBgTransLevel = 1008, ID_Check4NewVersion = 1009, ID_ShowDate = 1010, ID_SecondHandOn = 1011, _ 
	  ID_SecondHandOff = 1012, ID_SecondHandOnHover = 1013, ID_SecondHandStepping = 1014, ID_SecondHandType1 = 1015, ID_SecondHandType2 = 1016, ID_SecondHandType3 = 1017, _ 
	  ID_Snap = 1018
Dim Shared As HANDLE MainMenu, AppMenu, SettingsMenu, SecondHandSettings, SecondHandType

MainMenu = CreateMenu()
AppMenu = CreateMenu()
SettingsMenu = CreateMenu()
SecondHandSettings = CreateMenu()
SecondHandType = CreateMenu()

AppendMenu(AppMenu, MF_STRING, ID_About, "&About")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_AlwaysOnTop, "Always on &Top")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_ShowDate, "Show &Date")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_Autostart, "Auto&start with Windows")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_ClickThru, "Click T&hru")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_Reset, "&Reset Windows Position")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_Snap, "Enable &Window Snap")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_SecondHandStepping, "Enable Second Hand Ste&pping")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)

AppendMenu(AppMenu, MF_POPUP, Cast(Integer, SettingsMenu), "Customize Clock Visuals")
AppendMenu(SettingsMenu, MF_STRING, ID_SetGUISize, "Set &Clock Size")
AppendMenu(SettingsMenu, MF_SEPARATOR, 0, 0)
AppendMenu(SettingsMenu, MF_STRING, ID_SetGUITransLevel, "Set Clock UI Transparency &Level")
AppendMenu(SettingsMenu, MF_SEPARATOR, 0, 0)
AppendMenu(SettingsMenu, MF_STRING, ID_SetGUIBgTransLevel, "Set Clock Background Transparency &Level")
AppendMenu(SettingsMenu, MF_SEPARATOR, 0, 0)
AppendMenu(SettingsMenu, MF_POPUP, Cast(Integer, SecondHandSettings), "Settings Second Hand")
AppendMenu(SecondHandSettings, MF_STRING, ID_SecondHandOff, "Hide always second hand")
AppendMenu(SecondHandSettings, MF_STRING, ID_SecondHandOn, "Show always second hand")
AppendMenu(SecondHandSettings, MF_STRING, ID_SecondHandOnHover, "Show second hand only on hover over clock")
CheckMenuRadioItem(SecondHandSettings, 0, 2, iShowSeconds, MF_BYPOSITION)
AppendMenu(SettingsMenu, MF_SEPARATOR, 0, 0)
AppendMenu(SettingsMenu, MF_POPUP, Cast(Integer, SecondHandType), "Second Hand Type")
AppendMenu(SecondHandType, MF_STRING, ID_SecondHandType1, "Type 1 (default)")
AppendMenu(SecondHandType, MF_STRING, ID_SecondHandType2, "Type 2 (perforated)")
AppendMenu(SecondHandType, MF_STRING, ID_SecondHandType3, "Type 3 (standard)")
CheckMenuRadioItem(SecondHandType, 0, 2, iSecondHandType - 1, MF_BYPOSITION)

AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_Check4NewVersion, "&Check for new version")
AppendMenu(AppMenu, MF_SEPARATOR, 0, 0)
AppendMenu(AppMenu, MF_STRING, ID_Exit, "E&xit")

InsertMenu(MainMenu, 0, MF_POPUP, CPtr(UINT_PTR, AppMenu), 0)

Shell_NotifyIcon(NIM_ADD, @SystrayIcon)

If iAutostart = 1 Then CheckMenuItem(AppMenu, ID_Autostart, MF_CHECKED)
If iShowDate = 1 Then CheckMenuItem(AppMenu, ID_ShowDate, MF_CHECKED)
If iAlwaysOnTop = 1 Then CheckMenuItem(AppMenu, ID_AlwaysOnTop, MF_CHECKED)
If iClickThru = 1 Then CheckMenuItem(AppMenu, ID_ClickThru, MF_CHECKED)
If iSnap = 1 Then CheckMenuItem(AppMenu, ID_Snap, MF_CHECKED)
If iClockSecondHandStepping = 1 Then CheckMenuItem(AppMenu, ID_SecondHandStepping, MF_CHECKED)

'---------------------

'Region registry
Dim As Any Ptr hReg
Dim As String * 2048 sRegValue
Dim As ZString Ptr sNewRegValue
Dim As DWORD iRegValueLength
Dim As String sRegPath = Chr(34) & Command(0) & Chr(34) & Chr(0)

sNewRegValue = Allocate(Len(sRegPath) + 1)
*sNewRegValue = sRegPath

'open
RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", 0, KEY_ALL_ACCESS, @hReg)

If iAutostart = 1 Then
	RegSetValueEx(hReg, "SwissRailwayClock", NULL, REG_SZ, Cast(Byte Ptr, @sNewRegValue[0]), Len(*sNewRegValue))
ElseIf iAutostart = -1 Then
	RegDeleteValue(hReg, "SwissRailwayClock")
End If

RegFlushKey(hReg)

'---------------------


Dim Shared As Any Ptr hBitmap, hHBitmap, hCanvas, hBitmap_Clock, hBrush_Shadow, hBrush_Update, hPen_Update, hPen_SecondHand, hPen_Shadow, hScrDC, hMemDC, hOld, _
					  hBrush_date, hFamily_date, hStringFormat_date, hFont_date, hPath, hPath2, hPathS, hPathS2

Dim Shared As Point pSize
Dim Shared As Point pSource
Dim Shared As BLENDFUNCTION pBlend
pSize.x = iW
pSize.y = iH
With pBlend '...'
	.BlendOp = AC_SRC_OVER
	.BlendFlags = 0
	.SourceConstantAlpha = iAlpha
	.AlphaFormat = AC_SRC_ALPHA
End With

hScrDC = GetDC(hGUI)
hMemDC = CreateCompatibleDC(hScrDC)

GdipCreateBitmapFromScan0(iW, iH, 0, PixelFormat32bppARGB, 0, @hBitmap)
GdipGetImageGraphicsContext(hBitmap, @hCanvas)
GdipSetSmoothingMode(hCanvas, SmoothingModeAntiAlias)
GdipSetPixelOffsetMode(hCanvas, PixelOffsetModeHalf)
GdipSetTextRenderingHint(hCanvas, TextRenderingHintAntiAliasGridFit)
GdipCreatePath(0, @hPath)
GdipCreatePath(0, @hPath2)
GdipCreatePath(0, @hPathS)
GdipCreatePath(0, @hPathS2)

Dim Shared As ULong iShadowColor2 = &h90000000
GdipCreateSolidFill(iShadowColor, @hBrush_Shadow)
GdipCreateSolidFill(0, @hBrush_Update)
GdipCreatePen1(iClockCenterRingColor, 1.5, 2, @hPen_Update)
GdipCreatePen1(iClockSecondHandColor, 1, 2, @hPen_SecondHand)
GdipCreatePen1(iShadowColor, 1, 2, @hPen_Shadow)
GdipSetPenStartCap(hPen_SecondHand, LineCapTriangle)
GdipSetPenStartCap(hPen_Shadow, LineCapTriangle)

'String positions
Dim As RectF tLayout

Dim Shared As UShort fDiameter, fMin_next
Dim Shared As Single fShadowAngle, fRadius, fMSec
fDiameter = iW
fRadius = fDiameter / 2

Dim Shared As RectF tLayout_date

GdipCreateSolidFill(&hFF000000, @hBrush_date)
GdipCreateStringFormat(0, 0, @hStringFormat_date)
GdipCreateFontFamilyFromName("Segoe UI", NULL, @hFamily_date)
'GdipCreateFont(hFamily_date, 10, FontStyleRegular, UnitPoint, @hFont_date)
GdipSetStringFormatAlign(hStringFormat_date, StringAlignmentCenter)
GdipSetStringFormatLineAlign(hStringFormat_date, StringAlignmentCenter)

hBitmap_Clock = GenerateClockBg(fDiameter)

Dim Shared As Single fSec, fHr, fAmplitude = 3
Dim Shared As UByte iSec, iMin, iHr, iHr_Delta, bProcessShutdown = 0

Dim Shared As SYSTEMTIME tTime

GetSystemTime(@tTime)
iMin = tTime.wMinute
fMin_next = iMin
iHr_Delta = CUByte(Format(Now(), "hh")) - tTime.wHour

SetTimer(hGUI, 1, 30, Cast(Any Ptr, @Update))

Dim As Double fTimer = Timer
Dim As RECT tDesktop
Dim As HWND hHWND_Dt
Dim As Integer dx, dy, dw, dh
Dim Shared As Integer ScreenL, ScreenT, ScreenR, ScreenB, ScreenW, ScreenH
Dim tPos As RECT

hHWND_Dt = FindWindow("Progman","Program Manager")
GetWindowRect(hHWND_Dt, @tDesktop)
ScreenL = tDesktop.left
ScreenR = tDesktop.right
ScreenT = tDesktop.top
ScreenB = tDesktop.bottom
ScreenW = tDesktop.right + Abs(ScreenL)
ScreenH = tDesktop.bottom + Abs(ScreenT)

SetProcessShutdownParameters(&h3FF, 0)


While GetMessage(@Msg, 0, 0, 0) '...'
	TranslateMessage(@Msg)
	DispatchMessage(@Msg)
	If Timer - fTimer > 1 Then
		hHWND_Dt = FindWindow("Progman","Program Manager")
		GetWindowRect(hHWND_Dt, @tDesktop)
		dx = tDesktop.left
		dy = tDesktop.top
		dw = tDesktop.right + Abs(dx)
		dh = tDesktop.bottom + Abs(dy)
		GetWindowRect(hGUI, @tPos)
		If tPos.left < (dx - iW) Or tPos.left > dw Or tPos.top < (dy - iW) Or tPos.top > dh Then
			'SetWindowPos(hGUI, 0, Abs((ScreenW - ScreenR + xPos) / ScreenW * dw - dx - iW), Abs((ScreenH - ScreenB + yPos) / ScreenH * dh - dy - iH), 0, 0, 0)
			SetWindowPos(hGUI, 0, (xPos + Abs(ScreenL_old)) / ScreenW_old * dw - fDiameter * 0.70, (yPos + Abs(ScreenT_old)) / ScreenH_old * dh, 0, 0, 0)
		End If
		fTimer = Timer
	End If
	If bProcessShutdown = 1 Then Exit While
	If iShowSeconds = 2 Then 
		iHover = _WinAPI_IsCursorOverGui(hGUI)
	End If
Wend

KillTimer(hGUI, 1)
GetWindowRect(hGUI, @tPos)

_WinAPI_IniWrite(sPath2Ini, "Settings", "SwissRailwayClock", Str(iSwissRailwayClock))
_WinAPI_IniWrite(sPath2Ini, "Settings", "x", Str(tPos.left))
_WinAPI_IniWrite(sPath2Ini, "Settings", "y", Str(tPos.top))
_WinAPI_IniWrite(sPath2Ini, "Settings", "WinSize", Str(iW))
_WinAPI_IniWrite(sPath2Ini, "Settings", "Autostart", Str(iAutostart))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowDate", Str(iShowDate))
_WinAPI_IniWrite(sPath2Ini, "Settings", "AlwaysOnTop", Str(iAlwaysOnTop))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowSeconds", Str(iShowSeconds))
_WinAPI_IniWrite(sPath2Ini, "Settings", "Transparency", Str(iAlpha))
_WinAPI_IniWrite(sPath2Ini, "Settings", "BgTransparency", Str(iBgTransparency))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClickThru", Str(iClickThru))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ScreenL", Str(dx))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ScreenT", Str(dy))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ScreenR", Str(tDesktop.right))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ScreenB", Str(tDesktop.bottom))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ScreenW", Str(dw))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ScreenH", Str(dh))
_WinAPI_IniWrite(sPath2Ini, "Settings", "Snap", Str(iSnap))
_WinAPI_IniWrite(sPath2Ini, "Settings", "SnapGap", Str(iSnapGab))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowLogo", Str(iShowLogo))
_WinAPI_IniWrite(sPath2Ini, "Settings", "SecondHandTyp", Str(iSecondHandType))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockSecondHandStepping", Str(iClockSecondHandStepping))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowShadowBorder", Str(iShowShadowBorder))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowBrushedBorder", Str(iShowBrushedBorder))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowClockDial", Str(iShowClockDial))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowShadowSecondHand", Str(iShowShadowSecondHand))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowShadowMinuteHand", Str(iShowShadowMinuteHand))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShowShadowHourHand", Str(iShowShadowHourHand))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ShadowColor", Str("0x" & Hex(iShadowColor, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockDialColorBig", Str("0x" & Hex(iClockDialColorBig, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockDialColorSmall", Str("0x" & Hex(iClockDialColorSmall, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockBgColorStart", Str("0x" & Hex(iClockBgColorStart, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockBgColorEnd", Str("0x" & Hex(iClockBgColorEnd, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockSecondHandColor", Str("0x" & Hex(iClockSecondHandColor, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockMinuteHandColor", Str("0x" & Hex(iClockMinuteHandColor, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockHourHandColor", Str("0x" & Hex(iClockHourHandColor, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockCenterBottomColor", Str("0x" & Hex(iClockCenterBottomColor, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockCenterRingColor", Str("0x" & Hex(iClockCenterRingColor, 8)))
_WinAPI_IniWrite(sPath2Ini, "Settings", "ClockBrandingColor", Str("0x" & Hex(iClockBrandingColor, 8)))

If iAutostart = 1 Then
	RegSetValueEx(hReg, "SwissRailwayClock", NULL, REG_SZ, Cast(Byte Ptr, @sNewRegValue[0]), Len(*sNewRegValue))
ElseIf iAutostart = -1 Then
	RegDeleteValue(hReg, "SwissRailwayClock")
End If

RegFlushKey(hReg)

'close registry
RegCloseKey(hReg)
Deallocate(sNewRegValue)

'release resources
Shell_NotifyIcon(NIM_DELETE, @SystrayIcon)
DestroyIcon(HICON)
ReleaseDC(0, hScrDC)
DeleteDC(hMemDC)
GdipDeleteBrush(hBrush_date)
GdipDeleteFont(hFont_date)
GdipDeleteFontFamily(hFamily_date)
GdipDeleteStringFormat(hStringFormat_date)
GdipDeleteBrush(hBrush_Shadow)
GdipDeleteBrush(hBrush_Update)
GdipDeletePen(hPen_SecondHand)
GdipDeletePen(hPen_Update)
GdipDeletePen(hPen_Shadow)
GdipDisposeImage(hBitmap_Clock)
GdipDisposeImage(hBitmap)
GdipDeletePath(hPath)
GdipDeletePath(hPath2)
GdipDeletePath(hPathS)
GdipDeletePath(hPathS2)
GdipDeleteGraphics(hCanvas)
GdiplusShutdown(gdipToken)
End 0

Function _WinAPI_GetMonitorPosFromPoint(x As Long, y As Long) As RECT '...'
	Dim As Point tPos
	tPos.x = x
	tPos.y = y
	Dim As RECT tMonitorCoords
	Dim As HMONITOR hMonitor = MonitorFromPoint(tPos, MONITOR_DEFAULTTONULL) 'https://learn.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-monitorfrompoint
	If hMonitor = 0 Then Return tMonitorCoords
	Dim As MONITORINFO tMONITORINFO
	tMONITORINFO.cbSize = SizeOf(tMONITORINFO)
	If GetMonitorInfoW(hMonitor, @tMONITORINFO) = 0 Then Return tMonitorCoords
	tMonitorCoords.left = tMONITORINFO.rcMonitor.left
	tMonitorCoords.top = tMONITORINFO.rcMonitor.top
	tMonitorCoords.right = tMONITORINFO.rcMonitor.right
	tMonitorCoords.bottom = tMONITORINFO.rcMonitor.bottom
	Return tMonitorCoords
End Function

Function WndProc(hWnd As HWND, uMsg As UINT, wParam As WPARAM, lParam As LPARAM) As Integer
	Select Case hWnd
	Case hGUI
		Select Case uMsg
		Case WM_QUERYENDSESSION '...'
			bProcessShutdown = 1
		Case WM_CLOSE '...'
			If bGUIMsgbox = 0 Then
				DestroyWindow(hGUI)
				If hWND_About Then DestroyWindow(hWND_About)
				Return 0
			End If
		Case WM_DESTROY '...'
			If bGUIMsgbox = 0 Then PostQuitMessage(0)
			Return 0
		Case WM_NCHITTEST '...'
			Return HTCAPTION
		Case WM_SETCURSOR '...'
			If LoWord(lParam) = HTCAPTION And HiWord(lParam) = WM_LBUTTONDOWN Then
				SetCursor(CustomCursor)
				Return 1
			End If
		Case WM_KEYDOWN '...'
			If bGUIMsgbox = 0 AndAlso wParam = VK_ESCAPE Then
				PostMessage(hWnd, WM_CLOSE, 0, 0)
				Return 0
			End If
		Case WM_SHELLNOTIFY '...'
			If lParam = WM_RBUTTONDOWN Then
				Dim tPOINT As Point
				GetCursorPos(@tPOINT)
				SetForegroundWindow(hWnd)
				TrackPopupMenuEx(AppMenu, TPM_LEFTALIGN Or TPM_RIGHTBUTTON, tPOINT.x, tPOINT.y, hWnd, NULL)
				PostMessage(hWnd, WM_NULL, 0, 0)
			End If
		Case WM_WINDOWPOSCHANGING 'GUI snap to screen borders '...'
			If iSnap = 1 Then '...'
				Dim As Point mp
				GetCursorPos(@mp)
				Dim As RECT stRect = _WinAPI_GetMonitorPosFromPoint(mp.x, mp.y), tWorkArea
				SystemParametersInfo(SPI_GETWORKAREA, 0, @tWorkArea, 0)
				Dim As WINDOWPOS Ptr stWinPos
				stWinPos = Cast(WINDOWPOS Ptr, lParam)
				Dim As Short nLeft = stRect.left, nTop = stRect.top, nRight = stRect.right - stWinPos->cx, nBottom = min(stRect.bottom, tWorkArea.bottom) - stWinPos->cy
				If Abs(nLeft - stWinPos->x) <= iSnapGab Then stWinPos->x = nLeft - 2
				If Abs(nTop - stWinPos->y) <= iSnapGab Then stWinPos->y = nTop - 2
				If Abs(nRight - stWinPos->x) <= iSnapGab Then stWinPos->x = nRight + 2
				If Abs(nBottom - stWinPos->y) <= iSnapGab Then stWinPos->y = nBottom + 2
				Return 0
			End If
		Case WM_COMMAND
			Select Case LoWord (wParam) '...'
			Case ID_About '...'
				If bGUIMsgbox = 0 Then
					bGUIMsgbox = 1
					About(sScroller_Txt)
					bGUIMsgbox = 0
				End If
			Case ID_Exit '...'
				If bGUIMsgbox = 0 Then
					DestroyWindow(hGUI)
					If hWND_About Then DestroyWindow(hWND_About)
					Return 0
				End If
				Return 0
			Case ID_Reset '...'
				SetWindowPos(hGUI, 0, fDefaultPosX, fDefaultPosY, 0, 0, 0)
			Case ID_Autostart '...'
				If iAutostart = -1 Then
					CheckMenuItem(AppMenu, ID_Autostart, MF_CHECKED)
				Else
					CheckMenuItem(AppMenu, ID_Autostart, MF_UNCHECKED)
				End If
				iAutostart *= -1
			Case ID_ShowDate '...'
				If iShowDate = -1 Then
					CheckMenuItem(AppMenu, ID_ShowDate, MF_CHECKED)
				Else
					CheckMenuItem(AppMenu, ID_ShowDate, MF_UNCHECKED)
				End If
				iShowDate *= -1
			Case ID_SecondHandOn, ID_SecondHandOff, ID_SecondHandOnHover
				Select Case LoWord (wParam)
					Case ID_SecondHandOff
						iShowSeconds = 0
						CheckMenuRadioItem(SecondHandSettings, 0, 2, 0, MF_BYPOSITION)
						iHover = 0
					Case ID_SecondHandOn
						iShowSeconds = 1
						CheckMenuRadioItem(SecondHandSettings, 0, 2, 1, MF_BYPOSITION)
						iHover = 1
					Case ID_SecondHandOnHover
						iShowSeconds = 2
						CheckMenuRadioItem(SecondHandSettings, 0, 2, 2, MF_BYPOSITION)
						iHover = 0
				End Select
			Case ID_SecondHandType1, ID_SecondHandType2, ID_SecondHandType3
				Select Case LoWord (wParam)
					Case ID_SecondHandType1
						iSecondHandType = 1
						CheckMenuRadioItem(SecondHandType, 0, 2, 0, MF_BYPOSITION)
					Case ID_SecondHandType2
						iSecondHandType = 2
						CheckMenuRadioItem(SecondHandType, 0, 2, 1, MF_BYPOSITION)
					Case ID_SecondHandType3
						iSecondHandType = 3
						CheckMenuRadioItem(SecondHandType, 0, 2, 2, MF_BYPOSITION)
				End Select
			Case ID_SetGUITransLevel '...'
				If bGUITrans = 0 Then
					bGUITrans = 1
					CreateTransparentSettingWindow()
				End If
			Case ID_SetGUIBgTransLevel '...'
				CreateTransparentBgSettingWindow()
			Case ID_SetGUISize '...'
				If bGUISize = 0 Then
					bGUISize = 1
					CreateGUISizeSettingWindow()
				End If
			Case ID_AlwaysOnTop '...'
				If iAlwaysOnTop = -1 Then
					CheckMenuItem(AppMenu, ID_AlwaysOnTop, MF_CHECKED)
					SetWindowPos(hGUI, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
				Else
					CheckMenuItem(AppMenu, ID_AlwaysOnTop, MF_UNCHECKED)
					SetWindowPos(hGUI, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
				End If
				iAlwaysOnTop *= -1
			Case ID_ClickThru '...'
				If iClickThru = -1 Then
					CheckMenuItem(AppMenu, ID_ClickThru, MF_CHECKED)
					SetWindowLongPtr(hGUI, GWL_EXSTYLE, GetWindowLongPtr(hGUI, GWL_EXSTYLE) Or WS_EX_TRANSPARENT)
				Else
					CheckMenuItem(AppMenu, ID_ClickThru, MF_UNCHECKED)
					SetWindowLongPtr(hGUI, GWL_EXSTYLE, GetWindowLongPtr(hGUI, GWL_EXSTYLE) Xor WS_EX_TRANSPARENT)
				End If
				iClickThru *= -1
			Case ID_Snap '...'
				If iSnap = -1 Then
					CheckMenuItem(AppMenu, ID_Snap, MF_CHECKED)
				Else
					CheckMenuItem(AppMenu, ID_Snap, MF_UNCHECKED)
				End If
				iSnap *= -1
			Case ID_SecondHandStepping
				If iClockSecondHandStepping = -1 Then
					CheckMenuItem(AppMenu, ID_SecondHandStepping, MF_CHECKED)
				Else
					CheckMenuItem(AppMenu, ID_SecondHandStepping, MF_UNCHECKED)
				End If
				iClockSecondHandStepping *= -1
			Case ID_Check4NewVersion '...'
				Dim As String sNewVersion
				Dim As Byte res = Check4NewVersion(sTitle, sNewVersion)
				Select Case res
				Case 0
					MessageBox(hWnd, "No new version found online.", "Check for New Version", MB_OK)
				Case 1
					If MessageBox(hWnd, "New version found online!" & CRLF & CRLF & "Current version:  " & sVer & CRLF & "New version: " & sNewVersion & CRLF & "Visit website?", "Check for New Version", MB_YESNO) = IDYES Then
						ShellExecute(NULL, "open", "https://freebasic.net/forum/viewtopic.php?t=26454", NULL, NULL, SW_SHOWNORMAL)
					End If
				Case Else
					If Check4TLS() < 1 Then
						MessageBox(hWnd, "TLS 1.1 and TLS 1.2 must be enabled to check online for updates (see GDI+ Swiss Railway Clock.nfo)!", "Check for New Version", MB_ICONERROR)
					Else
						MessageBox(hWnd, "Error while connecting to site or reading web site: " & res, "Check 4 New Version", MB_ICONERROR)
					End If
					
				End Select
			End Select
		End Select
	Case hGUI_TransparentSettings '...'
		Select Case uMsg
		Case WM_CREATE
		Case WM_PAINT
			Dim As HBRUSH hBrush = CreateSolidBrush(&hF0F0F0)
			BeginPaint(hGUI_TransparentSettings, @tPaintStruct)
			FillRect(tPaintStruct.hdc, @tPaintStruct.rcPaint, hBrush)
			EndPaint(hGUI_TransparentSettings, @tPaintStruct)
			DeleteObject(hBrush)
		Case WM_COMMAND
			Select Case lParam
			Case hButton_TransparentSettings
				DestroyWindow(hGUI_TransparentSettings)
				bGUITrans = 0
				Return 0
			End Select
		Case WM_CLOSE
			DestroyWindow(hGUI_TransparentSettings)
			bGUITrans = 0
			pBlend.SourceConstantAlpha = iSliderPosPrev
			iAlpha = iSliderPosPrev
			Return 0
		Case WM_KEYDOWN
			If wParam = VK_ESCAPE Then
				DestroyWindow(hGUI_TransparentSettings)
				bGUITrans = 0
				pBlend.SourceConstantAlpha = iSliderPosPrev
				iAlpha = iSliderPosPrev
				Return 0
			End If
		Case WM_HSCROLL
			Select Case lParam
			Case hSlider_TransparentSettings
				iSliderPos = SendMessage(hSlider_TransparentSettings, TBM_GETPOS, 0, 0)
				SetWindowText(hLabel_TransparentSettings, Str(iSliderPos))
				pBlend.SourceConstantAlpha = iSliderPos
				iAlpha = iSliderPos
			End Select
		End Select
	Case hGUI_TransparentBgSettings '...'
		Select Case uMsg
		Case WM_CREATE
		Case WM_PAINT
			Dim As HBRUSH hBrush = CreateSolidBrush(&hF0F0F0)
			BeginPaint(hGUI_TransparentBgSettings, @tPaintStruct)
			FillRect(tPaintStruct.hdc, @tPaintStruct.rcPaint, hBrush)
			EndPaint(hGUI_TransparentBgSettings, @tPaintStruct)
			DeleteObject(hBrush)
		Case WM_COMMAND
			Select Case lParam
			Case hButton_TransparentBgSettings
				DestroyWindow(hGUI_TransparentBgSettings)
				bGUITrans = 0
				Return 0
			End Select
		Case WM_CLOSE
			DestroyWindow(hGUI_TransparentBgSettings)
			bGUITrans = 0
			iBgTransparency = iSliderPosPrev
			KillTimer(hGUI, 1)
			GdipDisposeImage(hBitmap_Clock)
			hBitmap_Clock = GenerateClockBg(fDiameter)
			SetTimer(hGUI, 1, 30, Cast(Any Ptr, @Update))
			Return 0
		Case WM_KEYDOWN
			If wParam = VK_ESCAPE Then
				DestroyWindow(hGUI_TransparentBgSettings)
				bGUITrans = 0
				iBgTransparency = iSliderPosPrev
				KillTimer(hGUI, 1)
				GdipDisposeImage(hBitmap_Clock)
				hBitmap_Clock = GenerateClockBg(fDiameter)
				SetTimer(hGUI, 1, 30, Cast(Any Ptr, @Update))
				Return 0
			End If
		Case WM_HSCROLL
			Select Case lParam
			Case hSlider_TransparentBgSettings
				iSliderPos = SendMessage(hSlider_TransparentBgSettings, TBM_GETPOS, 0, 0)
				SetWindowText(hLabel_TransparentBgSettings, Str(iSliderPos))
				iBgTransparency = iSliderPos
				KillTimer(hGUI, 1)
				GdipDisposeImage(hBitmap_Clock)
				hBitmap_Clock = GenerateClockBg(fDiameter)
				SetTimer(hGUI, 1, 30, Cast(Any Ptr, @Update))
			End Select
		End Select
	Case hGUI_GUISizeSettings '...'
		Select Case uMsg
		Case WM_CREATE
		Case WM_PAINT
			Dim As HBRUSH hBrush = CreateSolidBrush(&hF0F0F0) 'GUI background color
			BeginPaint(hGUI_GUISizeSettings, @tPaintStruct)
			FillRect(tPaintStruct.hdc, @tPaintStruct.rcPaint, hBrush)
			EndPaint(hGUI_GUISizeSettings, @tPaintStruct)
			DeleteObject(hBrush)
		Case WM_COMMAND
			Select Case lParam
			Case hButton_GUISizeSettings
				DestroyWindow(hGUI_GUISizeSettings)
				bGUISize = 0
				Return 0
			End Select
		Case WM_CLOSE
			DestroyWindow(hGUI_GUISizeSettings)
			bGUISize = 0
			SetGUISize(iSliderPosPrev)
			Return 0
		Case WM_KEYDOWN
			If wParam = VK_ESCAPE Then
				DestroyWindow(hGUI_GUISizeSettings)
				bGUISize = 0
				SetGUISize(iSliderPosPrev)
				Return 0
			End If
		Case WM_HSCROLL
			Select Case lParam
			Case hSlider_GUISizeSettings
				iSliderPos = SendMessage(hSlider_GUISizeSettings, TBM_GETPOS, 0, 0)
				SetWindowText(hLabel_GUISizeSettings, Str(iSliderPos) & " px")
				SetGUISize(iSliderPos)
			End Select
		End Select
	End Select
	Return DefWindowProc(hWnd, uMsg, wParam, lParam)
End Function

Sub SetGUISize(iSliderPos As Long) '...'
	KillTimer(hGUI, 1)
	iW = iSliderPos
	iH = iW
	fDiameter = iW
	fRadius = fDiameter / 2
	pSize.x = iW
	pSize.y = iW
	GdipDisposeImage(hBitmap_Clock)
	GdipDisposeImage(hBitmap)
	GdipDeleteGraphics(hCanvas)
	GdipCreateBitmapFromScan0(iW, iH, 0, PixelFormat32bppARGB, 0, @hBitmap)
	GdipGetImageGraphicsContext(hBitmap, @hCanvas)
	GdipSetSmoothingMode(hCanvas, SmoothingModeAntiAlias)
	GdipSetPixelOffsetMode(hCanvas, PixelOffsetModeHalf)
	hBitmap_Clock = GenerateClockBg(fDiameter)
	SetTimer(hGUI, 1, 30, Cast(Any Ptr, @Update))
End Sub

Sub CreateTransparentBgSettingWindow() '...'
	Dim As Short iW = 275, iH = 115, iDesktopPosX = GetSystemMetrics(SM_CXSCREEN) - iW, iDesktopPosY
	Dim As HWND hTaskbar = FindWindow("Shell_TrayWnd", NULL)
	Dim As RECT tRECT
	GetWindowRect(hTaskbar, @tRECT)
	iDesktopPosY = tRECT.top - iH
	hGUI_TransparentBgSettings = CreateWindowEx(WS_EX_APPWINDOW Or WS_EX_DLGMODALFRAME, _
	WinClass.lpszClassName, _ 'Class name
	"Transparency Background Setting", _ 'GUI name
	(WS_SYSMENU Or WS_CAPTION Or WS_VISIBLE), _
	iDesktopPosX - 4, _ 'x
	iDesktopPosY - 4, _ 'y
	iW, iH, _ 'w, h
	hGUI, _ 'hParent
	NULL, _ 'hMenu
	NULL, _ 'hInstance
	NULL) 'lpParam
	hSlider_TransparentBgSettings = CreateWindowEx(NULL, TRACKBAR_CLASS, "Trackbar Control", _
	WS_VISIBLE Or WS_CHILD Or TBS_NOTICKS Or TBS_ENABLESELRANGE Or TBS_TOOLTIPS Or TBS_BOTH, _
	4, 4, 200, 40, hGUI_TransparentBgSettings, NULL, NULL, NULL)
	SendMessage(hSlider_TransparentBgSettings, TBM_SETRANGE,True, MAKELONG(0, 255))
	SendMessage(hSlider_TransparentBgSettings, TBM_SETPOS, True, iBgTransparency)
	iSliderPosPrev = iBgTransparency
	hLabel_TransparentBgSettings = CreateWindowEx(NULL, "static", "", WS_VISIBLE Or WS_CHILD Or SS_CENTER Or SS_CENTERIMAGE Or SS_SUNKEN, 207, 9, 50, 18, hGUI_TransparentBgSettings, NULL, NULL, NULL)
	SetWindowText(hLabel_TransparentBgSettings, Str(iBgTransparency))
	hButton_TransparentBgSettings = CreateWindowEx(NULL, "Button", "Ok", WS_VISIBLE Or WS_CHILD, 4, 50, 260, 30, hGUI_TransparentBgSettings, NULL, NULL, NULL)
	'DestroyIcon(Cast(HANDLE, GetClassLong(hGUI_TransparentSettings, GCL_HICON)))
	'SetClassLong(hGUI_TransparentSettings, GCL_HICON, 0)
	'SetClassLong(hGUI_TransparentSettings, GCL_HICONSM, 0)
	_WinAPI_CreateToolTip(hSlider_TransparentBgSettings, "255 is opaque, 0 is full transparent")
End Sub

Sub CreateTransparentSettingWindow() '...'
	Dim As Short iW = 275, iH = 115, iDesktopPosX = GetSystemMetrics(SM_CXSCREEN) - iW, iDesktopPosY
	Dim As HWND hTaskbar = FindWindow("Shell_TrayWnd", NULL)
	Dim As RECT tRECT
	GetWindowRect(hTaskbar, @tRECT)
	iDesktopPosY = tRECT.top - iH
	hGUI_TransparentSettings = CreateWindowEx(WS_EX_APPWINDOW Or WS_EX_DLGMODALFRAME, _
	WinClass.lpszClassName, _ 'Class name
	"Transparency Setting", _ 'GUI name
	(WS_SYSMENU Or WS_CAPTION Or WS_VISIBLE), _
	iDesktopPosX - 4, _ 'x
	iDesktopPosY - 4, _ 'y
	iW, iH, _ 'w, h
	hGUI, _ 'hParent
	NULL, _ 'hMenu
	NULL, _ 'hInstance
	NULL) 'lpParam
	hSlider_TransparentSettings = CreateWindowEx(NULL, TRACKBAR_CLASS, "Trackbar Control", _
	WS_VISIBLE Or WS_CHILD Or TBS_NOTICKS Or TBS_ENABLESELRANGE Or TBS_TOOLTIPS Or TBS_BOTH, _
	4, 4, 200, 40, hGUI_TransparentSettings, NULL, NULL, NULL)
	SendMessage(hSlider_TransparentSettings, TBM_SETRANGE,True, MAKELONG(0, 255))
	SendMessage(hSlider_TransparentSettings, TBM_SETPOS, True, iAlpha)
	iSliderPosPrev = iAlpha
	hLabel_TransparentSettings = CreateWindowEx(NULL, "static", "", WS_VISIBLE Or WS_CHILD Or SS_CENTER Or SS_CENTERIMAGE Or SS_SUNKEN, 207, 9, 50, 18, hGUI_TransparentSettings, NULL, NULL, NULL)
	SetWindowText(hLabel_TransparentSettings, Str(iAlpha))
	hButton_TransparentSettings = CreateWindowEx(NULL, "Button", "Ok", WS_VISIBLE Or WS_CHILD, 4, 50, 260, 30, hGUI_TransparentSettings, NULL, NULL, NULL)
	'DestroyIcon(Cast(HANDLE, GetClassLong(hGUI_TransparentSettings, GCL_HICON)))
	'SetClassLong(hGUI_TransparentSettings, GCL_HICON, 0)
	'SetClassLong(hGUI_TransparentSettings, GCL_HICONSM, 0)
	_WinAPI_CreateToolTip(hSlider_TransparentSettings, "255 is opaque, 0 is full transparent")
End Sub

Sub CreateGUISizeSettingWindow() '...'
	Dim As Short iW_size = 275, iH_size = 115, iDesktopPosX = GetSystemMetrics(SM_CXSCREEN) - iW_size, iDesktopPosY
	Dim As HWND hTaskbar = FindWindow("Shell_TrayWnd", NULL)
	Dim As RECT tRECT
	GetWindowRect(hTaskbar, @tRECT)
	iDesktopPosY = tRECT.top - iH_size
	hGUI_GUISizeSettings = CreateWindowEx(WS_EX_APPWINDOW Or WS_EX_DLGMODALFRAME, _
	WinClass.lpszClassName, _ 'Class name
	"GUI Size Setting", _ 'GUI name
	(WS_SYSMENU Or WS_CAPTION Or WS_VISIBLE), _
	iDesktopPosX - 4, _ 'x
	iDesktopPosY - 4, _ 'y
	iW_size, iH_size, _ 'w, h
	hGUI, _ 'hParent
	NULL, _ 'hMenu
	NULL, _ 'hInstance
	NULL) 'lpParam
	hSlider_GUISizeSettings = CreateWindowEx(NULL, TRACKBAR_CLASS, "Trackbar Control", _
	WS_VISIBLE Or WS_CHILD Or TBS_NOTICKS Or TBS_ENABLESELRANGE Or TBS_TOOLTIPS Or TBS_BOTH, _
	4, 4, 200, 40, hGUI_GUISizeSettings, NULL, NULL, NULL)
	SendMessage(hSlider_GUISizeSettings, TBM_SETRANGE,True, MAKELONG(64, 800))
	SendMessage(hSlider_GUISizeSettings, TBM_SETPOS, True, fDiameter)
	iSliderPosPrev = fDiameter
	hLabel_GUISizeSettings = CreateWindowEx(NULL, "static", "", WS_VISIBLE Or WS_CHILD Or SS_CENTER Or SS_CENTERIMAGE Or SS_SUNKEN, 205, 9, 52, 18, hGUI_GUISizeSettings, NULL, NULL, NULL)
	SetWindowText(hLabel_GUISizeSettings, Str(fDiameter) & " px")
	hButton_GUISizeSettings = CreateWindowEx(NULL, "Button", "Ok", WS_VISIBLE Or WS_CHILD, 4, 50, 260, 30, hGUI_GUISizeSettings, NULL, NULL, NULL)
	_WinAPI_CreateToolTip(hSlider_GUISizeSettings, "Choose a size from 64 to 800 pixels!")
End Sub

'https://msdn.microsoft.com/en-us/library/windows/desktop/hh298368(v=vs.85).aspx
Function _WinAPI_CreateToolTip(hDlg As HWND, sToolTipText As String, bBalloon As UByte = 1) As HWND '...'
	If hDlg = 0 Or Len(sToolTipText) = 0 Then Return 0
	If Len(sToolTipText) > 79 Then Left(sToolTipText, 79)
	Dim hToolTip As HWND
	
	bBalloon = IIf(bBalloon > 1, 1, bBalloon)
	Dim As Long iStyle = bBalloon * TTS_BALLOON
	hToolTip = CreateWindowEx(NULL, TOOLTIPS_CLASS, NULL, _
	WS_POPUP Or TTS_NOPREFIX Or TTS_ALWAYSTIP Or iStyle, _
	CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
	hDlg, NULL, NULL, NULL)
	
	If hToolTip = 0 Then Return 0
	
	Dim tToolInfo As TOOLINFO
	With tToolInfo
		.cbSize = SizeOf(tToolInfo)
		.uFlags = TTF_SUBCLASS
		.hwnd = hDlg
		.hinst = NULL
		.lpszText = StrPtr(sToolTipText)
		.uId = 0
	End With
	GetClientRect(hDlg, @tToolInfo.rect)
	
	SendMessage(hToolTip, TTM_ADDTOOL, 0, Cast(LPARAM, @tToolInfo) )
	Return hToolTip
End Function

Sub Update()
	GdipGraphicsClear(hCanvas, &h00000000)
	GdipDrawImageRect(hCanvas, hBitmap_Clock, 0, 0, fDiameter, fDiameter)
	
	Static As ULong bBounce = 0, f = 0
	GetSystemTime(@tTime)
	fMSec = IIf(iClockSecondHandStepping = 1, Fix(tTime.wMilliseconds / 1000), tTime.wMilliseconds / 1000)
	iSec = tTime.wSecond
	iMin = tTime.wMinute
	'iHr = tTime.wHour + iHr_Delta
	iHr = CUByte(Format(Now(), "hh"))
	
	
	Dim As Single iWidth1 = fDiameter * 0.0375, _
				  iHeight1 = fDiameter / 2.5, _
				  iWidth12 = iWidth1 / 2, iWidth3, iHeight3, _
				  fPosY = fDiameter * 0.2, iWidth2, iWidth22, iWidth33, iWidth332, fPosY2, fPosY3, fPosY31, _
				  m1 = fDiameter * 0.015, fMin_
	
	'date
	tLayout_date.Width = fRadius
	tLayout_date.Height = fRadius * 1.6666
	tLayout_date.X = fRadius / 2
	tLayout_date.Y = fDiameter * 0.22
	If iShowDate = 1 AndAlso fDiameter > 149 Then '...'
		Dim As String aDays(0 To ...) = {"", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"}, sDate
		sDate = Date
		If hFont_date Then GdipDeleteFont(hFont_date)
		GdipCreateFont(hFamily_date, (fDiameter * 0.03) * fDPI, FontStyleBold, UnitPoint, @hFont_date)
		GdipDrawString(hCanvas, Right(sDate, 2) & "-" & Left(sDate, 2) & "-" & Mid(sDate, 4, 2) & " " & aDays(DatePart( "w", Now())), -1, hFont_date, @tLayout_date, hStringFormat_date, hBrush_date)
	End If
	
	'Draw Hour needle
	fHr = 30 * (iHr + iMin / 60)
	GdipTranslateWorldTransform(hCanvas, fRadius, fRadius, MatrixOrderPrepend)
	GdipRotateWorldTransform(hCanvas, fHr, MatrixOrderPrepend)
	GdipTranslateWorldTransform(hCanvas, -fRadius, -fRadius, MatrixOrderPrepend)
	GdipSetSolidFillColor(hBrush_Update, iClockHourHandColor)
	If iShowShadowHourHand Then '...'
		GdipFillRectangle(hCanvas, hBrush_Shadow, _
													fRadius - iWidth12 + Cos((fShadowAngle - fHr) * fRad) * m1, _
													fPosY + Sin((fShadowAngle - fHr) * fRad) * m1, _
													iWidth1, iHeight1)
	End If
	GdipFillRectangle(hCanvas, hBrush_Update, _
												fRadius - iWidth12, _
												fPosY, _
												iWidth1, iHeight1)
	GdipResetWorldTransform(hCanvas)
	
	'Draw Minute needle
	If iSwissRailwayClock Then
		If fMin_next <> iMin Then bBounce = 1
		If bBounce = 1 Then
			fMin_ = (6 * ((fMin_next + 1) Mod 60)) + Sin(f * 1.9) * fAmplitude
			If fAmplitude = 0 Then
				fMin_next = iMin
				f = 0
				fAmplitude = 3
				bBounce = 0
			Else
				fAmplitude -= 0.5
				fAmplitude = IIf(fAmplitude <= 0, 0, fAmplitude)
				f += 1
			End If
		Else
			fMin_ = 6 * iMin
		End If
	Else
		fMin_ = 6 * (iMin + iSec / 60)
	End If
	GdipTranslateWorldTransform(hCanvas, fRadius, fRadius, MatrixOrderPrepend)
	GdipRotateWorldTransform(hCanvas, fMin_, MatrixOrderPrepend)
	GdipTranslateWorldTransform(hCanvas, -fRadius, -fRadius, MatrixOrderPrepend)
	iWidth1 = fDiameter * 0.03
	iHeight1 = fRadius
	iWidth12 = iWidth1 / 2
	fPosY = fDiameter * 0.1
	If iShowShadowMinuteHand Then '...'
		GdipFillRectangle(hCanvas, hBrush_Shadow, _
													fRadius - iWidth12 + Cos((fShadowAngle - fMin_) * fRad) * m1, _
													fPosY + Sin((fShadowAngle - fMin_) * fRad) * m1, _
													iWidth1, iHeight1)
	End If
	
	GdipSetSolidFillColor(hBrush_Update, iClockMinuteHandColor)
	GdipFillRectangle(hCanvas, hBrush_Update, _
												fRadius - iWidth12, _
												fPosY, _
												iWidth1, iHeight1)
	GdipResetWorldTransform(hCanvas)
	
	iWidth1 = fDiameter * 0.0095
	If IIf(iShowSeconds, 1, 0) And iHover Then '...'
		'Draw Second needle
		If iSwissRailwayClock Then 
			fSec = IIf(iClockSecondHandStepping = 1, 6 * Fix(iSec * 1.02564 + fMSec), 6 * (iSec * 1.02564 + fMSec))
		Else
			fSec = IIf(iClockSecondHandStepping = 1, 6 * Fix(iSec + fMSec), 6 * (iSec + fMSec))
		End If
		If fSec >= 360 Then fSec = 0
		GdipTranslateWorldTransform(hCanvas, fRadius, fRadius, MatrixOrderPrepend)
		GdipRotateWorldTransform(hCanvas, fSec, MatrixOrderPrepend)
		GdipTranslateWorldTransform(hCanvas, -fRadius, -fRadius, MatrixOrderPrepend)
		iWidth12 = iWidth1 / 2	
		GdipSetSolidFillColor(hBrush_Update, iClockSecondHandColor)
		
		Select Case iSecondHandType
			Case 1
				fPosY = fDiameter * 0.27
				fPosY2 = fDiameter * 0.19
				iWidth2 = fDiameter * 0.083333
				iWidth22 = iWidth2 / 2
				iHeight1 = fRadius * 1.3 - fPosY
				'Draw shadow of Second needle
				If iShowShadowSecondHand Then '...'
					GdipFillRectangle(hCanvas, hBrush_Shadow, _
																fRadius + Cos((fShadowAngle - fSec) * fRad) * m1, _
																fPosY + Sin((fShadowAngle - fSec) * fRad) * m1, _
																iWidth1 + fDiameter * 0.006667, iHeight1 + fDiameter * 0.006667)
					GdipFillEllipse(hCanvas, hBrush_Shadow, _
																fRadius - iWidth22 + Cos((fShadowAngle - fSec) * fRad) * m1, _
																fPosY2 + Sin((fShadowAngle - fSec) * fRad) * m1, _
																iWidth2, iWidth2)
				End If
				
				'Draw Second needle				
				GdipFillRectangle(hCanvas, hBrush_Update, fRadius - iWidth12, fPosY, iWidth1, iHeight1)
				GdipFillEllipse(hCanvas, hBrush_Update, fRadius - iWidth22, fPosY2, iWidth2, iWidth2)
			Case 2 '...'
				fPosY3 = fDiameter * 0.129
				fPosY31 = fDiameter * 0.25
				iWidth3 = fDiameter * 0.0175
				iHeight3 = fRadius * 1.3 - fPosY3
				iWidth33 = fDiameter * 0.12
				iWidth332 = iWidth33 / 2
				
				Dim As Double c1 = iWidth332 / 2
				
				'Draw shadow of Second needle
				If iShowShadowSecondHand Then
					GdipResetPath(hPathS)
					GdipResetPath(hPathS2)
					GdipResetClip(hCanvas)
					GdipSetPathFillMode(hPathS, FillModeWinding)
					
					GdipAddPathRectangle(hPathS, fRadius - iWidth3 / 2 + Cos((fShadowAngle - fSec) * fRad) * m1, _ 
												fPosY3 + Sin((fShadowAngle - fSec) * fRad) * m1, _ 
												iWidth3 + fDiameter * 0.006667, iHeight3 + fDiameter * 0.006667)
					GdipAddPathEllipse(hPathS, fRadius - iWidth332 + Cos((fShadowAngle - fSec) * fRad) * m1, _
											  fPosY31 + Sin((fShadowAngle - fSec) * fRad) * m1, _ 
											  iWidth33, iWidth33)
					GdipAddPathEllipse(hPathS2, fRadius - c1 + Cos((fShadowAngle - fSec) * fRad) * m1, _ 
											   fPosY31 + c1 + Sin((fShadowAngle - fSec) * fRad) * m1, c1 * 2, c1 * 2)
	   				GdipSetClipPath(hCanvas, hPathS2, CombineModeExclude)
					GdipFillPath(hCanvas, hBrush_Shadow, hPathS)
				End If
								
				'Draw Second needle
				GdipResetPath(hPath)
				GdipResetPath(hPath2)
				GdipResetClip(hCanvas)
				GdipSetPathFillMode(hPath, FillModeWinding)
				
				GdipAddPathRectangle(hPath, fRadius - iWidth3 / 2, fPosY3, iWidth3, iHeight3)
				GdipAddPathEllipse(hPath, fRadius - iWidth332, fPosY31, iWidth33, iWidth33)			
				'GdipAddPathArc(hPath, fRadius - iWidth332, fPosY31, iWidth33, iWidth33, 0, 360)
				GdipAddPathEllipse(hPath2, fRadius - c1, fPosY31 + c1, c1 * 2, c1 * 2)
   				GdipSetClipPath(hCanvas, hPath2, CombineModeExclude)
				GdipFillPath(hCanvas, hBrush_Update, hPath)
				GdipResetClip(hCanvas)
				GdipDrawEllipse(hCanvas, hPen_Update, fRadius - c1, fPosY31 + c1, c1 * 2, c1 * 2)
			Case 3
				fPosY = fDiameter * 0.115
				iHeight1 = fRadius * 1.3 - fPosY
				iWidth3 = fRadius - iWidth12
				GdipSetPenWidth(hPen_SecondHand, fRadius * 0.03)
				If iShowShadowSecondHand Then
					GdipSetPenWidth(hPen_Shadow, fRadius * 0.03)
					GdipDrawLine(hCanvas, hPen_Shadow, iWidth3 + Cos((fShadowAngle - fSec) * fRad) * m1, fPosY + Sin((fShadowAngle - fSec) * fRad) * m1, _
													   iWidth3 + iWidth1 + fDiameter * 0.006667, fPosY + iHeight1 + fDiameter * 0.006667)
				End If
				GdipDrawLine(hCanvas, hPen_SecondHand, iWidth3, fPosY, iWidth3 + iWidth1, fPosY + iHeight1)
				
				/'fPosY3 = fDiameter * 0.129
				iWidth3 = fDiameter * 0.0175
				iHeight3 = fRadius * 1.3 - fPosY3
				GdipResetPath(hPath)
				GdipAddPathRectangle(hPath, fRadius - iWidth3 / 2, fPosY3, iWidth3, iHeight3)
				GdipFillPath(hCanvas, hBrush_SecondHand, hPath)'/
		End Select

		GdipResetWorldTransform(hCanvas)
	End If
	
	'button in the center
	iWidth1 *= 1.5
	GdipSetSolidFillColor(hBrush_Update, iClockCenterBottomColor)
	GdipFillEllipse(hCanvas, hBrush_Update, _
												fRadius - iWidth1, _
												fRadius - iWidth1, _
												2 * iWidth1, 2 * iWidth1)
	GdipDrawEllipse(hCanvas, hPen_Update, _
												fRadius - iWidth1, _
												fRadius - iWidth1, _
												2 * iWidth1, 2 * iWidth1)
	
	'Draw To Screen
	GdipCreateHBITMAPFromBitmap(hBitmap, @hHBitmap, &hFF000000)
	
	hOld = SelectObject(hMemDC, hHBitmap)
	UpdateLayeredWindow(hGUI, hScrDC, NULL, Cast(Any Ptr, @pSize), hMemDC, Cast(Any Ptr, @pSource), 0, Cast(Any Ptr, @pBlend), ULW_ALPHA)
	SelectObject(hMemDC, hOld)
	DeleteObject(hHBitmap)
End Sub

Function GenerateClockBg(fDiameter As UShort) As Any Ptr
	Dim As Any Ptr hBitmap_Logo, hBitmap_tmp, hGfx, hGfx2
	
	'decompress base91 encoded image
	Static As ULong iLines = 0, bCompressed, iFileSize, iCompressedSize
	Dim As String sBaseType, sBase91, aB91(1)
	Static As UByte Ptr aBinary

	If iLines = 0 OrElse aBinary = 0 Then '...'
		Restore __fblogopng:
		Read iLines
		Read bCompressed
		Read iFileSize
		Read iCompressedSize
		Read sBaseType
		For i As UShort = 0 To iLines - 1
			Read aB91(0)
			sBase91 &= aB91(0)
		Next
		
		Dim As ULong iLenB91
		aBinary = Base91Decode(sBase91, iLenB91)
	End If

	Dim As Any Ptr hBitmap, hBrush, hBrushCDB, hBrushCDS, hBrushL, hBrushLB, hPen, hPenL, hFamily, hStringFormat, hFont, hMatrix
	Dim As Single fBorderSize = fDiameter * 0.03333
	GdipCreatePen1(iShadowColor2, fBorderSize, 2, @hPen)
	Dim As Single fSize = fDiameter * 0.9475 - fBorderSize / 2, fRadius = fDiameter / 2, fShadow_vx = fDiameter * 0.0095, fShadow_vy = fDiameter * 0.01
	Dim As GpPointF tPoint1, tPoint2

	Dim As Single iWidth1 = fDiameter * 0.026667, iHeight1 = fDiameter / 10, iWidth12 = iWidth1 / 2, fPosY = fDiameter * 0.083333, _
			      iWidth2 = fDiameter * 0.013333, iHeight2 = fDiameter * 0.0416667, iWidth22 = iWidth2 / 2	
			
	GdipCreateBitmapFromScan0(fDiameter, fDiameter, 0, PixelFormat32bppARGB, 0, @hBitmap)
	GdipGetImageGraphicsContext(hBitmap, @hGfx)
	GdipSetSmoothingMode(hGfx, 4)
	GdipSetPixelOffsetMode(hGfx, 4)
	GdipSetTextRenderingHint(hGfx, 4)
	
	tPoint1.X = fBorderSize
	tPoint1.Y = fBorderSize
	tPoint2.X = fSize
	tPoint2.Y = fSize
	GdipCreateLineBrush(@tPoint1, @tPoint2, iBgTransparency Shl 24 Or iClockBgColorStart, iBgTransparency Shl 24 Or iClockBgColorEnd, 3, @hBrushLB)
	'GdipSetLineGammaCorrection(hBrushLB, TRUE)
	GdipSetLineSigmaBlend(hBrushLB, 0.5, 0.85)
	
	GdipCreateMatrix(@hMatrix)
	GdipTranslateMatrix(hMatrix, fSize * 2, fSize * 2, 1)
	GdipRotateMatrix(hMatrix, 90, 1)
	GdipTranslateMatrix(hMatrix, -fSize * 2, -fSize * 2, 1)
	GdipMultiplyLineTransform(hBrushLB, hMatrix, 0)
	GdipDeleteMatrix(hMatrix)
	
	'background color
	If iShowBrushedBorder = 0 And iShowShadowBorder = 0 Then
		GdipFillEllipse(hGfx, hBrushLB, fPosY, fPosY, fSize * 0.89, fSize * 0.89)
	Else 
		GdipFillEllipse(hGfx, hBrushLB, fBorderSize, fBorderSize, fSize, fSize)
	End If
	
	'shadow border
	If iShowShadowBorder Then '...'
		fShadowAngle = Atn(fShadow_vy / fShadow_vx) * fDeg
		If fShadow_vx < 0 And fShadow_vy >= 0 Then fShadowAngle += 180
		If fShadow_vx < 0 And fShadow_vy < 0 Then fShadowAngle -= 180
		GdipDrawEllipse(hGfx, hPen, fBorderSize + fShadow_vx, fBorderSize + fShadow_vy, fSize, fSize)
		_GDIPlus_BitmapApplyFilter_FastBoxBlur(hBitmap, fDiameter * 0.015)
	End If
	
	
	'brushed aluminium border
	If iShowBrushedBorder Then '...'
		tPoint1.X = 0
		tPoint1.Y = 0
		tPoint2.X = fSize
		tPoint2.Y = fSize
		GdipCreateLineBrush(@tPoint1, @tPoint2, &hAFFFFFFF, &hFF000000, 3, @hBrushL)
		GdipSetLineSigmaBlend(hBrushL, 0.6, 1.0)
		GdipSetLineGammaCorrection(hBrushL, True)
		GdipCreatePen2(hBrushL, fBorderSize, UnitPixel, @hPenL)
		GdipDrawEllipse(hGfx, hPenL, fBorderSize, fBorderSize, fSize, fSize)
	End If
	
	GdipCreateSolidFill(iClockBrandingColor, @hBrush)
	GdipCreateSolidFill(iClockDialColorBig, @hBrushCDB)
	GdipCreateSolidFill(iClockDialColorSmall, @hBrushCDS)
	
	
	GdipTranslateWorldTransform(hGfx, fRadius, fRadius, 0)
	GdipRotateWorldTransform(hGfx, -6.0, MatrixOrderPrepend)
	GdipTranslateWorldTransform(hGfx, -fRadius, -fRadius, 0)
	
	'clock face
	If iShowClockDial Then
		For i As UByte = 0 To 59
			GdipTranslateWorldTransform(hGfx, fRadius, fRadius, 0)
			GdipRotateWorldTransform(hGfx, 6.0, MatrixOrderPrepend)
			GdipTranslateWorldTransform(hGfx, -fRadius, -fRadius, 0)
			If (i Mod 5) = 0 Then
				GdipFillRectangle(hGfx, hBrushCDB, fRadius - iWidth12, fPosY, iWidth1, iHeight1)
			Else
				GdipFillRectangle(hGfx, hBrushCDS, fRadius - iWidth22, fPosY, iWidth2, iHeight2)
			End If
		Next
	End If
	GdipResetWorldTransform(hGfx)
	
	Dim As GpRectF tLayout
	
	tLayout.Width = fRadius * 0.4
	tLayout.Height = fRadius * 0.4
	tLayout.X = fRadius - fRadius * 0.2
	tLayout.Y = fRadius + fRadius * IIf(fDiameter < 150 Or iShowDate <> 1, 0.225, 0.275)
	
	If tOSVERSIONINFO.dwBuildNumber < 6000 Then
		GdipCreateFontFamilyFromName("Comic Sans MS", NULL, @hFamily)
	Else
		GdipCreateFontFamilyFromName("Segoe Script", NULL, @hFamily)
	End If
	GdipCreateStringFormat(0, 0, @hStringFormat)
	GdipCreateFont(hFamily, fDiameter * 0.025 * fDPI, FontStyleBold, UnitPoint, @hFont)
	GdipSetStringFormatAlign(hStringFormat, StringAlignmentCenter)
	GdipSetStringFormatLineAlign(hStringFormat, StringAlignmentCenter)
	GdipSetTextRenderingHint(hCanvas, TextRenderingHintAntiAliasGridFit)
	GdipDrawString(hGfx, "Clock by" & CRLF & "UEZ", -1, hFont, @tLayout, hStringFormat, hBrush)
	
	If iShowLogo Then 
		Dim As Single fLogoSize = fDiameter * 15, fLogoW, fLogoH, fTmp
		hBitmap_tmp = _GDIPlus_BitmapCreateFromMemory2(@aBinary[0], iFileSize)
		GdipGetImageDimension(hBitmap_tmp, @fLogoW, @fLogoH)
		fTmp = fLogoW
		fLogoW = fLogoSize / fLogoH
		fLogoH = fLogoSize / fTmp
		GdipCreateBitmapFromScan0(fLogoW, fLogoH, 0, PixelFormat32bppARGB, 0, @hBitmap_Logo)
		GdipGetImageGraphicsContext(hBitmap_Logo, @hGfx2)
		GdipSetInterpolationMode(hGfx2, 7)
		GdipDrawImageRect(hGfx2, hBitmap_tmp, 0, 0, fLogoW, fLogoH)
		GdipDrawImageRect(hGfx, hBitmap_Logo, fRadius - fLogoW / 2, fRadius / 2.0, fLogoW, fLogoH)
		GdipDisposeImage(hBitmap_tmp)
	EndIf
	
	GdipDisposeImage(hBitmap_Logo)
	GdipDeleteFont(hFont)
	GdipDeleteFontFamily(hFamily)
	GdipDeleteStringFormat(hStringFormat)
	GdipDeleteBrush(hBrush)
	GdipDeleteBrush(hBrushCDB)
	GdipDeleteBrush(hBrushCDS)
	GdipDeleteBrush(hBrushL)
	GdipDeleteBrush(hBrushLB)
	GdipDeletePen(hPen)
	GdipDeletePen(hPenL)
	GdipDeleteGraphics(hGfx)
	GdipDeleteGraphics(hGfx2)
	Return hBitmap
End Function

Function _GDIPlus_BitmapCreateFromMemory2(aBinImage As UByte Ptr, iLen As ULong, bBitmap_GDI As BOOL = False) As Any Ptr '...'
	Dim As HGLOBAL hGlobal
	Dim As LPSTREAM hStream
	Dim As Any Ptr hBitmap_Stream
	Dim As Any Ptr hMemory = GlobalAlloc(GMEM_MOVEABLE, iLen)
	Dim As Any Ptr lpMemory = GlobalLock(hMemory)
	RtlCopyMemory(lpMemory, @aBinImage[0], iLen)
	GlobalUnlock(hMemory)
	CreateStreamOnHGlobal(hMemory, 0, @hStream)
	GdipCreateBitmapFromStream(hStream, @hBitmap_Stream)
	IUnknown_Release(hStream)
	
	If bBitmap_GDI = True Then
		Dim hBitmap_GDI As Any Ptr
		GdipCreateHBITMAPFromBitmap(hBitmap_Stream, @hBitmap_GDI, &hFF000000)
		GdipDisposeImage(hBitmap_Stream)
		Return hBitmap_GDI
	End If
	
	Return hBitmap_Stream
End Function

Function _GDIPlus_GraphicsGetDPIRatio(iDPIDef As UShort = 96) As Single '...'
	Dim As Any Ptr hGfx
	Dim As Single fDPI = 0.0
	GdipCreateFromHWND(0, @hGfx)
	GdipGetDpiX(hGfx, @fDPI)
	GdipDeleteGraphics(hGfx)
	Return iDPIDef / fDPI
End Function


'https://lotsacode.wordpress.com/2010/12/08/fast-blur-box-blur-With-accumulator/
Sub _GDIPlus_BitmapApplyFilter_FastBoxBlur(ByVal hImage As Any Ptr, range As ULong) '...'
	If (range Mod 2) = 0 Then range += 1
	FastBoxBlurH(hImage, range)
	FastBoxBlurV(hImage, range)
End Sub

Sub FastBoxBlurH(hImage As Any Ptr, range As ULong) '...'
	Dim As Single w, h
	GdipGetImageDimension(hImage, @w, @h)
	
	Dim As BitmapData tBitmapData
	Dim As RECT tRect = Type(0, 0, w, h)
	
	Dim As Long halfRange = range \ 2, index = 0, NewColors(0 To w), hits, a, r, g, b, oldPixel, col, newPixel
	
	GdipBitmapLockBits(hImage, Cast(Any Ptr, @tRect), ImageLockModeRead Or ImageLockModeWrite, PixelFormat32bppARGB, @tBitmapData)
	For y As UInteger = 0 To h - 1
		a = 0
		r = 0
		g = 0
		b = 0
		hits = 0
		For x As Integer = -halfRange To w - 1
			oldPixel = x - halfRange - 1
			If oldPixel >= 0 Then
				col = Cast(ULong Ptr, tBitmapData.Scan0)[index + oldPixel]
				If col <> 0 Then
					a -= CUByte(col Shr 24)
					r -= CUByte(col Shr 16)
					g -= CUByte(col Shr 8)
					b -= CUByte(col)
				End If
				hits -= 1
			End If
			newPixel = x + halfRange
			If newPixel < w Then
				col = Cast(ULong Ptr, tBitmapData.Scan0)[index + newPixel]
				If col <> 0 Then
					a += CUByte(col Shr 24)
					r += CUByte(col Shr 16)
					g += CUByte(col Shr 8)
					b += CUByte(col)
				End If
				hits += 1
			End If
			If x >= 0 Then
				NewColors(x) = (CUByte(a / hits) Shl 24) Or (CUByte(r / hits) Shl 16) Or (CUByte(g / hits) Shl 8) Or CUByte(b / hits)
			End If
		Next
		For x As UInteger = 0 To w - 1
			Cast(ULong Ptr, tBitmapData.Scan0)[index + x] = NewColors(x)
		Next
		index += w
	Next
	GdipBitmapUnlockBits(hImage, @tBitmapData)
End Sub

Sub FastBoxBlurV(hImage As Any Ptr, range As ULong) '...'
	Dim As Single w, h
	GdipGetImageDimension(hImage, @w, @h)
	
	Dim As BitmapData tBitmapData
	Dim As RECT tRect = Type(0, 0, w, h)
	
	Dim As Long halfRange = range \ 2, index, NewColors(0 To h), hits, a, r, g, b, oldPixel, col, newPixel, _
	oldPixelOffset = -(halfRange + 1) * w, newPixelOffset = (halfRange) * w
	
	GdipBitmapLockBits(hImage, Cast(Any Ptr, @tRect), ImageLockModeRead Or ImageLockModeWrite, PixelFormat32bppARGB, @tBitmapData)
	For x As UInteger = 0 To w - 1
		hits = 0
		a = 0
		r = 0
		g = 0
		b = 0
		index = -halfRange * w + x
		For y As Integer = -halfRange To h - 1
			oldPixel = y - halfRange - 1
			If oldPixel >= 0 Then
				col = Cast(ULong Ptr, tBitmapData.Scan0)[index + oldPixelOffset]
				If col <> 0 Then
					a -= CUByte(col Shr 24)
					r -= CUByte(col Shr 16)
					g -= CUByte(col Shr 8)
					b -= CUByte(col)
				End If
				hits -= 1
			End If
			newPixel = y + halfRange
			If newPixel < h Then
				col = Cast(ULong Ptr, tBitmapData.Scan0)[index + newPixelOffset]
				If col <> 0 Then
					a += CUByte(col Shr 24)
					r += CUByte(col Shr 16)
					g += CUByte(col Shr 8)
					b += CUByte(col)
				End If
				hits += 1
			End If
			If y >= 0 Then
				NewColors(y) = (CUByte(a / hits) Shl 24) Or (CUByte(r / hits) Shl 16) Or (CUByte(g / hits) Shl 8) Or CUByte(b / hits)
			End If
			index += w
		Next
		For y As UInteger = 0 To h - 1
			Cast(ULong Ptr, tBitmapData.Scan0)[y * w + x] = NewColors(y)
		Next
	Next
	GdipBitmapUnlockBits(hImage, @tBitmapData)
End Sub

Function _WinAPI_IsCursorOverGui(hWnd As HWND) As BOOL '...'
	Dim As Point tCursorPoint
	GetCursorPos(@tCursorPoint)
	ScreenToClient(hWnd, @tCursorPoint)
	Dim As RECT tGuiRect
	GetClientRect(hWnd, @tGuiRect)
	Return PtInRect(@tGuiRect, tCursorPoint)
End Function


'https://msdn.microsoft.com/en-us/library/ms724353.aspx
Function _WinAPI_IniRead(sIniFile As String, sSection As String, sKey As String, sDefault As String = "default") As String '...'
	Dim As ZString * 1024 Buffer
	Dim As Integer iResult = GetPrivateProfileString(sSection, sKey, sDefault, @Buffer, SizeOf(Buffer), sIniFile)
	Return Buffer
End Function

'https://msdn.microsoft.com/en-us/library/ms725500(v=vs.85).aspx
Function _WinAPI_IniWrite(sIniFile As String, sSection As String, sKey As String, sValue As String = "default") As Integer '...'
	Dim As ZString * 1024 Buffer
	Dim As Integer iResult = WritePrivateProfileString(sSection, sKey, sValue, sIniFile)
	Return iResult
End Function

'https://docs.microsoft.com/en-us/windows/desktop/api/winuser/nf-winuser-setprocessdpiaware
Function _WinAPI_SetProcessDpiAware() As UByte '...'
	Dim As Any Ptr hLib = DyLibLoad("user32.dll")
	Dim pSetProcessDPIAware As Function() As UByte
	pSetProcessDPIAware = DyLibSymbol(hLib, "SetProcessDPIAware")
	Dim As UByte iReturn = pSetProcessDPIAware()
	DyLibFree(hLib)
	If iReturn = 0 Then Return 0
	Return 1
End Function

'https://docs.microsoft.com/en-us/windows/desktop/api/shellscalingapi/nf-shellscalingapi-setprocessdpiawareness
Function _WinAPI_SetProcessDpiAwareness(DPIAwareFlag As Integer) As UByte '...'
	Dim As Any Ptr hLib = DyLibLoad("Shcore.dll")
	Dim pSetProcessDpiAwareness As Function(ByVal DPIAwareFlag As Integer) As UByte
	pSetProcessDpiAwareness = DyLibSymbol(hLib, "SetProcessDpiAwareness")
	Dim As ULong iReturn = pSetProcessDpiAwareness(DPIAwareFlag)
	DyLibFree(hLib)
	If iReturn <> 0 Then Return 0
	Return 1
End Function

Function WndProc_About(hWnd As HWND, nMsg As UINT,wParam As WPARAM,lParam As LPARAM) As Integer '...'
	Select Case As Const nMsg
	Case WM_DESTROY
		KillTimer(hWnd, 1)
		PostQuitMessage(0)
	Case WM_CLOSE
		DestroyWindow(hWND_About)
	Case WM_KEYDOWN
		Select Case As Const wParam
		Case VK_ESCAPE
			PostMessage(hWND_About, WM_CLOSE, 0, 0)
		End Select
	Case WM_TIMER
		KillTimer(hWND_About, 1)
		Static As Double t = 0
		Dim As Long i
		Dim As Double x, y, j, jj, q, f
		GdipGraphicsClear(hCanvas_About, &hF0FFFFFF)
		For i = 3e3 - 1 To 0 Step -1
			If (i And 256) = 0 Then
				f = fmod(t, 1)
				j = 3e3 / (i / 64 + f * 8)
				x = iw2 - (3 - Sin(t) - (i Mod 8)) * j
				y = ih2 + ((Fix(i / 8) And 7) - 3.7 + f) * j
				jj = j / 2
				q = LimCol(2e4 / j)
				GdipSetSolidFillColor(hBrush_About, (255 - q) Shl 24 Or q Shl 16 Or q Shl 8 Or q)
				GdipFillRectangle(hCanvas_About, hBrush_About, x, y , jj, jj)
			End If
		Next
		GdipDrawImageRect(hCanvas_About, hBitmap_Scroller_About, 0, iStartPos_Scroller_About, iW_About, iH_ScrollerTxt)
		BitBlt(hDC_About, 0, 0, iW_About, iH_About, hDC_backbuffer_About, 0, 0, SRCCOPY)
		t += 0.0083333333
		If Timer - fTimer_About > 5 Then iStartPos_Scroller_About -= 1
		If iStartPos_Scroller_About < -iH_ScrollerTxt Then iStartPos_Scroller_About = iH_About
		SetTimer(hWND_About, 1, 1, NULL)
	End Select
	Return DefWindowProc(hWnd, nMsg, wParam, lParam)
End Function

Sub About(sScroller_Txt As String) '...'
	SetPriorityClass(GetCurrentProcess(), ABOVE_NORMAL_PRIORITY_CLASS)
	Dim wc As WNDCLASSEX
	Dim msg As MSG
	Dim As Integer sW, sH
	ScreenInfo(sW, sH)
	
	Dim szAppName As ZString * 6 => "FB GUI"
	Dim As String sTitle = "About"
	With wc
		.style         = CS_HREDRAW Or CS_VREDRAW
		.lpfnWndProc   = @WndProc_About
		.hInstance     = GetModuleHandle(NULL)
		.hIcon         = LoadIcon(.hInstance, IDI_APPLICATION)
		.hCursor       = LoadCursor(NULL, IDC_ARROW)
		.lpszClassName = @szAppName
		.cbSize		   = SizeOf(WNDCLASSEX)
	End With
	
	RegisterClassEx(@wc)
	hWND_About = CreateWindowEx(WS_EX_TOPMOST, wc.lpszClassName, sTitle, WS_OVERLAPPEDWINDOW Or WS_VISIBLE Xor WS_MAXIMIZEBOX, _
	(sW - iW_About) / 2, (sH - iH_About) / 2, _	'display GUI centered
	iW_About, iH_About, _
	hGUI, NULL, wc.hInstance, NULL)
	
	hDC_About = GetDC(hWND_About)
	Dim As BITMAPINFO tBITMAP
	Dim As ULong Ptr aBitmap
	With tBITMAP.bmiHeader
		.biSize = SizeOf(BITMAPINFOHEADER)
		.biWidth = iW_About
		.biHeight = -iH_About
		.biPlanes = 1
		.biBitCount = 32
		.biCompression = BI_RGB
	End With
	hHBitmap_About = CreateDIBSection(hDC_About, @tBITMAP, DIB_RGB_COLORS, @aBitmap, NULL, NULL)
	
	hDC_backbuffer_About = CreateCompatibleDC(hDC_About)
	hDC_obj_About = SelectObject(hDC_backbuffer_About, hHBitmap_About)
	
	GdipCreateFromHDC(hDC_backbuffer_About, @hCanvas_About)
	GdipSetSmoothingMode(hCanvas_About, SmoothingModeAntiAlias)
	GdipSetPixelOffsetMode(hCanvas_About, PixelOffsetModeHalf)
	GdipCreateSolidFill(&hFFFF0000, @hBrush_About)
	GdipCreatePen1(&h80000000, 2, 2, @hPen_About)
	
	Dim As Any Ptr hFont_About, hFamily_About, hFormat_About, hGfx_About, hPath_About
	Dim As GpRectF tLayout_About, tLayout_txt_About
	
	GdipCreateStringFormat(0, 0, @hFormat_About)
	GdipCreateFontFamilyFromName("Consolas", 0, @hFamily_About)
	GdipCreateFont(hFamily_About, 24 * fDPI, 0, 3, @hFont_About)
	GdipSetStringFormatAlign(hFormat_About, StringAlignmentCenter)
	GdipSetStringFormatLineAlign(hFormat_About, StringAlignmentCenter)
	
	tLayout_About.X = 0
	tLayout_About.Y = 0
	tLayout_About.Width = iW_About
	tLayout_About.Height = iH_About * 10
	GdipMeasureString(hCanvas_About, sScroller_Txt, Len(sScroller_Txt), hFont_About, @tLayout_About, hFormat_About, @tLayout_txt_About, NULL, NULL)
	iH_ScrollerTxt = tLayout_txt_About.Height
	GdipCreateBitmapFromScan0(iW_About, iH_ScrollerTxt, 0, PixelFormat32bppARGB, 0, @hBitmap_Scroller_About)
	GdipGetImageGraphicsContext(hBitmap_Scroller_About, @hGfx_About)
	GdipSetSmoothingMode(hGfx_About, SmoothingModeAntiAlias)
	GdipSetPixelOffsetMode(hGfx_About, PixelOffsetModeHalf)
	GdipSetTextRenderingHint(hGfx_About, TextRenderingHintAntiAliasGridFit)
	GdipSetSolidFillColor(hBrush_About, &hC0F80000)
	tLayout_About.X = -tLayout_txt_About.X / 4
	tLayout_About.Y = 0
	tLayout_About.Width = iW_About
	tLayout_About.Height = iH_ScrollerTxt
	GdipCreatePath(0, @hPath_About)
	GdipAddPathString(hPath_About, sScroller_Txt, -1, hFamily_About, 0, 24, @tLayout_About, hFormat_About)
	GdipDrawPath(hGfx_About, hPen_About, hPath_About)
	GdipFillPath(hGfx_About, hBrush_About, hPath_About)
	'GdipDrawString(hGfx_About, sScroller_Txt, -1, hFont_About, @tLayout_About, hFormat_About, hBrush_About)
	fTimer_About = Timer
	iStartPos_Scroller_About = 0
	SetTimer(hWND_About, 1, 30, NULL)
	
	While GetMessage(@msg, 0, 0, 0)
		TranslateMessage(@msg)
		DispatchMessage(@msg)
	Wend
	
	'GDI
	SelectObject(hDC_backbuffer_About, hDC_obj_About)
	DeleteDC(hDC_backbuffer_About)
	DeleteObject(hHBitmap_About)
	ReleaseDC(hWND_About, hDC_About)
	
	'GDIPlus
	GdipDeletePath(hPath_About)
	GdipDeleteGraphics(hGfx_About)
	GdipDisposeImage(hBitmap_Scroller_About)
	GdipDeleteFont(hFont_About)
	GdipDeleteFontFamily(hFamily_About)
	GdipDeleteStringFormat(hFormat_About)
	GdipDeletePen(hPen_About)
	GdipDeleteBrush(hBrush_About)
	GdipDeleteGraphics(hCanvas_About)
	SetPriorityClass(GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS)
End Sub

Function Check4TLS() As Long '...'
	Dim As SYSTEM_INFO tSYSTEM_INFO 'https://docs.microsoft.com/en-us/windows/win32/api/sysinfoapi/ns-sysinfoapi-system_info
	GetNativeSystemInfo(@tSYSTEM_INFO)
	Dim As Any Ptr hReg, hReg2
	Dim As Long iReturn
	
	Dim As DWORD BinaryType
	GetBinaryType(Command(0), @BinaryType)
	If tSYSTEM_INFO.wProcessorArchitecture = 9 And BinaryType = 0 Then
		iReturn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp", 0, KEY_QUERY_VALUE, @hReg)
		If iReturn Then Return -iReturn
		iReturn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Internet Settings", 0, KEY_QUERY_VALUE, @hReg2)
		If iReturn Then Return -iReturn
	Else
		iReturn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp", 0, KEY_QUERY_VALUE, @hReg)
		If iReturn Then Return -iReturn
		iReturn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings", 0, KEY_QUERY_VALUE, @hReg2)
		If iReturn Then Return -iReturn
	End If
	
	Dim As DWORD iRegValue, iRegValue2, iRegValueLength = SizeOf(DWORD)
	RegQueryValueEx(hReg, "DefaultSecureProtocols", NULL, NULL, Cast(Byte Ptr, @iRegValue), @iRegValueLength)
	RegQueryValueEx(hReg2, "SecureProtocols", NULL, NULL, Cast(Byte Ptr, @iRegValue2), @iRegValueLength)
	RegCloseKey(hReg)
	RegCloseKey(hReg2)
	If (iRegValue And &h0A00) /'And (iRegValue2 And &h0A00)'/ Then Return 3 'TLS 1.1 and TLS 1.2 supported
	If (iRegValue And &h0800) /'And (iRegValue2 And &h0800)'/ Then Return 2 'TLS 1.2 supported
	If (iRegValue And &h0200) /'And (iRegValue2 And &h0200)'/ Then Return 1 'TLS 1.1 supported
	Return 0							  								'either TLS 1.1 or TLS 1.2 is not supported
End Function

Function Check4NewVersion(check As String, ByRef sNewVersion As String) As Byte '...'
	If _WinHttpStartup() = False Then Return -1
	Dim As Any Ptr hSession, hConnect, hRequest
	Dim As String sRead, sGrab
	hSession = _WinHttpOpen()
	If hSession = 0 Then Return -2
	hConnect = _WinHttpConnect(hSession, "freebasic.net")
	If hConnect = 0 Then Return -3
	hRequest = _WinHttpSimpleSendRequest(hConnect, "forum/viewtopic.php?t=26454")
	If hRequest = 0 Then Return -4
	sRead = _WinHttpSimpleReadData(hRequest)
	_WinHttpCloseHandle(hRequest)
	_WinHttpCloseHandle(hConnect)
	_WinHttpCloseHandle(hSession)
	_WinHttpShutdown()
	sRead = Mid(sRead, 200, 100)
	sGrab = Mid(sRead, InStr(sRead, " [Windows only!] - freebasic.net</title>") - InStr(sRead, "<title>GDI+ Swiss Railway Clock v") - 41, 47)
	If Left(sGrab, 26) <> "GDI+ Swiss Railway Clock v" Then Return -5
	sNewVersion = Mid(sGrab, 26, 22)
	Return IIf(sGrab = check, 0, 1)
End Function

Function Base91Decode(sString As String, ByRef iBase91Len As ULong) As UByte Ptr '...'
	Dim As String sB91, sDecoded
	sB91 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!#$%&()*+,./:;<=>?@[]^_`{|}~" ' instead of "
	Dim As Long i, n = 0, c, b = 0, v = -1
	
	Dim aChr(0 To Len(sString) - 1) As String
	For i = 0 To UBound(aChr)
		aChr(i) = Mid(sString, i + 1, 1)
	Next
	
	For i = 0 To UBound(aChr)
		c = InStr(sB91, aChr(i)) - 1
		If v < 0 Then
			v = c
		Else
			v += c * 91
			b = b Or (v Shl n)
			n += 13 + (((v And 8191) <= 88) * -1)
			Do Until  (n > 7)=0
				sDecoded &= Chr(b And 255)
				b = b Shr 8
				n -= 8
			Loop
			v = -1
		End If
	Next
	If (v + 1) Then
		sDecoded &= Chr((b Or (v Shl n)) And 255)
	End If
	iBase91Len = Len(sDecoded)
	
	'workaround for multiple embedded file other crash will occure
	Static As UByte aReturn(0 To iBase91Len - 1)
	ReDim aReturn(0 To iBase91Len - 1) As UByte
	
	For i = 0 To iBase91Len - 1 'convert result String To ascii code values
		aReturn(i) = Asc(sDecoded, i + 1)
	Next
	Return @aReturn(0)
End Function

'Generated by FB File2Bas Code Generator v0.75 build 2018-02-22 beta by UEZ

__fblogopng:
Data 2,0,1153,1414,"Base91"
Data "vuk:eJs4+BAAN/<MCG4DAA]BABt;LMAAA7f9(}mAABtHOyc:[rn<AAAAAAAAAAAAAAAAAAAAAAAuWV9,AACkUNU8DII#}#~Slo5wT5|AA$AjzLH:OVl|gjw#J1D?vIyB|~~d+josXA#3?:G!q&|O1H5dJ?`5FN^g~q?<V@)Zq1~NzdZ`cB~je:_p1IVdVE<Gv`Bc>t^8hvX_/oC@k~}:Zd{2{[_+!i8(>f]4^[52>q=Rs&zcF#r49<R&@Bkonle8lyBRZp}51[^hHOw3s0D?40,~QAn_{VvkkTT+SB,_IL*:o&T.^?Uf(aqd*Wu$.C&YS%)mT<!Zy%(:GhWT2?M0Y^gL@Tgr$rG%E/38g~k?){JS!+GL;;.5XiJ`t^YdDcl69,/3)X0Lmb~V.uaZhB*XiVN/{b}=^%/m4B0/?UY9BClk*[=u7Q2pe||>Bma<Xo,@K9w&D0]Y]fL.m{^q6fo#o?s|!5n28B5v4_K{S$|^40VRNi&M9Lj0E{`m#oTm{0Q+EO3kU%2Jf)CP.v0(&L(BvuJ[p?<52bp|Ix2Zx2D%kRW8Hqb.pG{=%p61&5dz485;vdo/RK3]ybZ:n2gOm?M7`htJXUt+K@1FmGD7OGQDC|/oG@j+LxT)[+}1_+A~4n4i|k8Nid`}Y>u=2?5[%],{BAufOdTByv$c3tK$Pa=xL;rEQ;)<.m_BBA~AUglG*)7Q`]pA^[&%c].zx973mnRu7sJCj^mc_Raruk]g..s$%UuQX`yf_z@,n:%&BT43VNNsc5,>G62yFjQS)v5Vc&BjTHA%;kup+|$$)m_!&Cx>bPCkb^kz=VTWsF}RB.aa/2z!5y)vz_$>Alt~5a}+LI2$4Bk$DN2Hn6*}r{eu!7,O5O[BAJ|0_g>^=n/pPO"
Data "I0[4{>@]SV<Ujeuoa>t`Pwh.oy.j@iJd1T&:nmpq[lW:VL}KPBu,bICM0aj&&)SL=T0qd7MKk#C``}x.f,`p%9i}[|GZ]b6Cy:5?(+`bGE)cl!a896/E9db3:Xl|%DWqh+<2_?7[*]~lLbl;)W/77fax=B3J!WLi_PJb%MW$O*r2N@}_$LB$cTl.4*Hy&<I&BJE?nm8M0Ku>Yz^vP?nCPcq!&WNfqW}CF/3x/t2:Y=mt6!c(Ct|m&uZbXb2]qCy$d$u$B5u|{*{_m4|2/*]+@`*&.zG^oQX:OEn53]Qs2<~4p5|@!=cPvA&Q<gm|V$>RViL/o_G9ZA5Um@=;Um@,vukV2O.HI:^*{Qxg(//5VfJ(O&nU}[[U2+/9A?A2yFie@^%+?MLn041;*NWtCf}y/d3Y]_prkVI/&:?T8]fR&S?o1[vgR@L4c4Cr8hETG46Pk]y3U/c=fKsZFTb9n/=$*4)ASiZ+5m0_v|9xpid!xAqoSg%BAACnHpwZ9)&F"
